/* ge -- gtk editor
 * with apologies - derived from the Erwin HTML gtk editor
 * changes (C) 2002, Terry Loveall <loveall@qwest.net>
 * Copyright 1999 David Vogler <david@rhlx01.rz.fht-esslingen.de>
 *		  Adrian Reber <adrian@rhlx01.rz.fht-esslingen.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */


#include "ge.h"

GtkStyle *style = NULL;
GdkFont *font = NULL;

char file[1024]= "FILENAME";
gchar *FileName = "nothing";
GtkWidget *main_window;

#ifdef LIBRARY
void * (* extern_function)(char *);
#endif

void save_file ()
{
  FILE *fd;
  gchar *ge;

  if (strcmp(file,"FILENAME"))
    {
#ifdef DEBUG
      g_print("\nNow saving file %s\n",file);
#endif
      if (gtk_text_get_length(GTK_TEXT(text)))
	{
	    if(!is_file_readonly(file))
		{
#ifdef DEBUG
	    g_print("\nNow writing to file %s",file);
#endif
		fd=fopen(file,"w");
	    /*if (!access(file,W_OK))*/
	      {
		ge=gtk_editable_get_chars(GTK_EDITABLE(text),0,-1);
		fprintf(fd,"%s",ge);
		g_free(ge);
	      }
	    fclose(fd);
	    set_title_name();
#ifdef LIBRARY
	    extern_function(file);
#endif		 
	    }
	  else

	    {
	      display_dialog("Error","Insufficient permissions\n to write that file");

	    }
	}
      else
	{
	  if(!is_file_readonly(file))
	    {
	      fd=fopen(file,"w");
	      fclose(fd);
	      {
		set_title_name();
	      }
	    }
	}
    }
  else
    {
      save_file_dlg();
    }
}

void display_main_window (void)
{
  GtkWidget *hbox;
  GtkWidget *scrollbar;
  GtkWidget *vbox;
  GtkWidget *main_vbox;
  GtkWidget *menubar;
  GtkWidget *toolbar;
  GtkWidget *toolbox;
  gchar ge [1024] ="";
  FILE *fd;

  main_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (main_window), NAME " - Untitled");
  gtk_window_position (GTK_WINDOW (main_window), GTK_WIN_POS_CENTER);
  gtk_container_border_width (GTK_CONTAINER (main_window), 5);


  gtk_widget_set_usize (GTK_WIDGET (main_window), 600, 400);
/*   
			(gint) (0.7 * gdk_screen_width ()),
			(gint) (0.6 * gdk_screen_height ()));
*/ 
  gtk_signal_connect (GTK_OBJECT (main_window), "delete_event",
		      GTK_SIGNAL_FUNC (quit_program), NULL);
  gtk_signal_connect (GTK_OBJECT (main_window), "key_press_event",
		      GTK_SIGNAL_FUNC (check_key), NULL);
  gtk_widget_realize(main_window);

  main_vbox= gtk_vbox_new (FALSE, 5);
  gtk_container_add (GTK_CONTAINER (main_window),main_vbox);
  text = gtk_text_new (NULL, NULL);
  vbox = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start(GTK_BOX(main_vbox), vbox, FALSE, FALSE, 0);

  /*--- the menubar ---*/
  main_menu(main_window,&menubar);
  gtk_box_pack_start(GTK_BOX(vbox), menubar, FALSE, FALSE, 0);
  gtk_widget_show(menubar);
  /*--- the end of menubar ---*/

  hbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start(GTK_BOX(main_vbox), hbox, TRUE, TRUE, 0);

   /*---toolbar    ---*/
  toolbox= gtk_vbox_new(FALSE,0);
  gtk_box_pack_start(GTK_BOX(vbox),toolbox,FALSE,FALSE,0);
  toolbar= main_toolbar(main_window,text);
  gtk_box_pack_start(GTK_BOX(toolbox), toolbar, FALSE, FALSE, 0);
  gtk_widget_show(toolbar);
  gtk_widget_show(toolbox);
  gtk_widget_show(vbox);
  /*---toolbar-end--*/

  style = gtk_style_copy (gtk_widget_get_style (GTK_WIDGET (text)));
  gtk_style_ref (style);
  font = gdk_font_load ("-adobe-courier-medium-r-normal--*-120-*-*-*-*-*-*");
//  font = gdk_font_load ("-adobe-helvetica-medium-r-normal--*-120-*-*-*-*-*-*");
  gdk_font_ref (font);
  style->font = font;
  gtk_widget_set_style (GTK_WIDGET (text), style);
  gtk_text_set_editable (GTK_TEXT (text), TRUE);
  gtk_text_set_word_wrap (GTK_TEXT (text), TRUE);
  gtk_box_pack_start(GTK_BOX (hbox), text, TRUE, TRUE, 4);

  if ((fd = fopen (file, "r")))
    {
       gtk_text_freeze(GTK_TEXT(text));
      while (fgets (ge, 1024, fd))
	{
	  gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL,
			   ge, strlen (ge));
	  gtk_editable_set_position(GTK_EDITABLE(text),0);
	}
      fclose (fd);
	set_title_name();
	gtk_text_thaw(GTK_TEXT(text));
    }

  gtk_widget_show (text);
  scrollbar = gtk_vscrollbar_new (GTK_TEXT (text)->vadj);
  gtk_box_pack_start(GTK_BOX (hbox), scrollbar, FALSE, FALSE, 0);
  gtk_widget_show (scrollbar);
  gtk_widget_show (hbox);
  gtk_widget_show (main_vbox);
  gtk_widget_show (main_window);
  gtk_window_set_focus(GTK_WINDOW(main_window),text);
}

#ifndef LIBRARY
int main (int argc, char *argv[])
{
  FILE *fd;
  GString * bla;
  gtk_init (&argc, &argv);

  if (argc==2)
    {
      if (!(fd = fopen (argv[1], "r")))
	{
	if((fd = fopen (argv[1], "w")))
	{
	strcpy(file,argv[1]);
	fclose(fd);
	}
	}
      else
	{
	strcpy(file,argv[1]);
	fclose(fd);
	}

    }
  if (strcmp(file,"FILENAME"))
    {
#ifdef DEBUG
g_print("\nis path absolute ? %d",g_path_is_absolute(file));
#endif
	if (!g_path_is_absolute(file))
	{
	bla=g_string_new(g_get_current_dir());
	bla=g_string_append(bla,"/");
	bla=g_string_append(bla,file);
	strcpy(file,bla->str);
	g_string_free(bla,TRUE);
	}
#ifdef DEBUG
     g_print("\ng_basename %s",g_basename(file));
     g_print("\nis path absolute ? %d",g_path_is_absolute(file));
	g_print("\ng_get_current_dir %s",g_get_current_dir());
	g_print("\ng_dirname %s",g_dirname(file));
      g_print("\nNow opening %s\n", file);
#endif
    }
  else
    {
#ifdef DEBUG
      g_print("\nNow opening without file...");
#endif
    }

#ifdef DEBUG
  signal (SIGSEGV, SIG_DFL);
#endif
  display_main_window ();
  gtk_main ();
  return EXIT_SUCCESS;
}

#else


GtkWidget * GTK_editor (char *filename, void *function)
{
  GString * bla;

  if (!g_path_is_absolute(filename)) {
    bla=g_string_new(g_get_current_dir());
    bla=g_string_append(bla,"/");
    bla=g_string_append(bla, filename);
    strcpy(file, bla->str);
    g_string_free(bla,TRUE);
  }
  else
    strcpy(file, filename);

  extern_function = function;
   
  display_main_window ();
  return main_window;
}

void GTK_editor_set_file( char *filename)
{
  gchar ge[1025];
  FILE *fd;
  gint length=0;

  if (!strcmp(filename, "FILENAME")) return;   
  gtk_text_freeze(GTK_TEXT(text));
  length=gtk_text_get_length(GTK_TEXT(text));
#ifdef DEBUG
  g_print("\nLength of Text : %d",length);
#endif
  gtk_editable_delete_text(GTK_EDITABLE(text),0,length);
  fd = fopen(filename,"r");
  strcpy(file, filename);
  if(fd==NULL)
    {
#ifdef DEBUG
      g_print("Can't open file for reading\n");
#endif
      gtk_text_thaw(GTK_TEXT(text));
      return;
    }
  while(fgets(ge, 1024, fd)!=NULL)
    {
      gtk_text_insert (GTK_TEXT (text), NULL, NULL, NULL,
		       ge, strlen (ge));
    }
  fclose(fd);
  set_title_name();
  gtk_text_thaw(GTK_TEXT(text));
}

#endif /* LIBRARY */
