/* ge -- gtk editor
 * Copyright 1999 David Vogler <david@rhlx01.rz.fht-esslingen.de>
 *		  Adrian Reber <adrian@rhlx01.rz.fht-esslingen.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "ge.h"

extern char file[1024];
static GtkWidget *find_dialog = NULL;
extern gint from_beginning;

void help_about_menu (GtkWidget *widget)
{
  display_dialog("About ...",NAME " - gtk editor\n
ge comes with ABSOLUTELY NO WARRANTY - see GPL.");
}

void message ()
{
  display_dialog("Message ...","Text is too short to save");
}

void open_file_dlg()
{
  GtkWidget       *filew;
  filew = gtk_file_selection_new ("Open File");
  gtk_signal_connect (GTK_OBJECT (filew), "destroy", (GtkSignalFunc) destroy_message, &filew);
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked", (GtkSignalFunc) open_file_ok, filew);
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), "clicked", (GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (filew));
  /*gtk_file_selection_set_filename (GTK_FILE_SELECTION(filew), "nothing");*/
  gtk_widget_show(filew);
}

void save_file_dlg()
{
  GtkWidget       *filew;
  filew = gtk_file_selection_new ("Save File As");
  gtk_signal_connect (GTK_OBJECT (filew), "destroy", (GtkSignalFunc) destroy_message, &filew);
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked", (GtkSignalFunc) save_file_ok, filew);
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), "clicked", (GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (filew));
  if (strcmp(file,"FILENAME"))
    {
      gtk_file_selection_set_filename (GTK_FILE_SELECTION(filew), file);
    }
  gtk_widget_show(filew);
}

void close_find_dialog (GtkWidget *widget, gpointer data)
{
  gtk_widget_destroy (GTK_WIDGET(data));
  from_beginning=0;
  find_dialog = NULL;
}

void find_dlg()
{
  GtkWidget * button, *button1;
  GtkWidget * hbox, * main_box, * frame_box, * button_box;
  GtkWidget * frame;
  static struct frame_entry frame_entry;

  if (find_dialog)
	{
	#ifdef DEBUG
	g_print("\nDialog already open...\n");
	#endif
 	gdk_window_raise(find_dialog->window);
	return;
   	}

  find_dialog=gtk_dialog_new();

  gtk_signal_connect (GTK_OBJECT (find_dialog), "destroy",
		      GTK_SIGNAL_FUNC (close_find_dialog),
		      find_dialog);
  gtk_window_set_title (GTK_WINDOW (find_dialog), "Find");
  gtk_window_position (GTK_WINDOW (find_dialog), GTK_WIN_POS_CENTER);
  gtk_container_border_width (GTK_CONTAINER (find_dialog), 5);
  main_box=gtk_vbox_new(TRUE,TRUE);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (find_dialog)->vbox),
		      main_box, TRUE, TRUE, 1);
  hbox = gtk_hbox_new (TRUE, TRUE);
  gtk_box_pack_start (GTK_BOX (main_box),
		      hbox, TRUE, TRUE, 2);
  entry_in_frame ("Find What?", &frame_entry);
  gtk_box_pack_start (GTK_BOX (hbox),
		      frame_entry.frame, TRUE, TRUE, 0);
  if(to_be_searched)
    {
      gtk_entry_set_text(GTK_ENTRY(frame_entry.entry),to_be_searched);
    }
  GTK_WIDGET_SET_FLAGS(GTK_WIDGET(frame_entry.entry),GTK_CAN_DEFAULT);
  gtk_widget_show (hbox);
  frame_box= gtk_vbox_new(FALSE,FALSE);
  gtk_box_pack_start (GTK_BOX (main_box),
		      frame_box, FALSE, FALSE, 2);
  frame = gtk_frame_new("Options");
  gtk_box_pack_start (GTK_BOX (frame_box),
		      frame, FALSE, FALSE, 0);
  gtk_frame_set_label_align (GTK_FRAME(frame),0,0);
  button_box= gtk_vbox_new(FALSE,FALSE);
  gtk_container_add (GTK_CONTAINER(frame),button_box);
  find_options.case_sensitive=gtk_check_button_new_with_label("Case Sensitive");
  gtk_box_pack_start (GTK_BOX (button_box),
		      GTK_WIDGET(find_options.case_sensitive), FALSE, FALSE, 0);
  /* If entry is changed, search from start should be enabled again*/
  gtk_widget_show (GTK_WIDGET(find_options.case_sensitive));

  find_options.from_beginning=gtk_check_button_new_with_label("Start at beginning");
  gtk_box_pack_start (GTK_BOX (button_box),
		      GTK_WIDGET(find_options.from_beginning), FALSE, FALSE, 0);
   gtk_signal_connect (GTK_OBJECT (find_options.from_beginning), "clicked",
		      GTK_SIGNAL_FUNC (find_entry_changed), NULL);

  gtk_widget_show (GTK_WIDGET(find_options.from_beginning));
  gtk_widget_show (frame);
  gtk_widget_show(button_box);
  gtk_widget_show(frame_box);

  gtk_widget_show(main_box);
  button1 = gtk_button_new_with_label ("Find Next");
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);
  gtk_signal_connect (GTK_OBJECT (button1), "clicked",
		      GTK_SIGNAL_FUNC (find_function),
		      frame_entry.entry);

  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (find_dialog)->action_area),
		      button1, FALSE, FALSE, 0);

  gtk_widget_show (button1);
  button = gtk_button_new_with_label ("Cancel");
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (close_find_dialog),
		      find_dialog);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (find_dialog)->action_area),
		      button, FALSE, FALSE,0);
   gtk_signal_connect (GTK_OBJECT (frame_entry.entry), "key_press_event",
		      GTK_SIGNAL_FUNC (find_entry_changed),NULL );

  gtk_widget_show (button);
  gtk_widget_grab_default (button1);

  gtk_widget_show(find_dialog);

}

