/* ge -- gtk editor
 * Copyright 1999 David Vogler <david@rhlx01.rz.fht-esslingen.de>
 *                Adrian Reber <adrian@rhlx01.rz.fht-esslingen.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef GE_FUNCTIONS_H
#define GE_FUNCTIONS_H
#include "gedef.h"
/* All gefunctions.c prototypes */

void copy_to_clipboard (GtkWidget *);
void cut_to_clipboard (GtkWidget *);
void paste_from_clipboard (GtkWidget *);
void insert_text (char * , gint);
void file_ok_sel (GtkWidget *, GtkFileSelection *);
gint move_cursor (gpointer , gint , GeCursor);
struct change test_selection (gpointer);
void insert_text_around (gpointer,struct change, char *,gint);
GdkColor * get_main_tooltips_bgcolor(GdkWindow *, GdkColormap *);
void destroy_message(GtkWidget *);
gint delete_event(GtkWidget *, GdkEvent *, gpointer);
void quit_program (GtkWidget *, gpointer);
void check_key(GtkWidget *, GdkEventKey *);
void find_entry_changed(GtkWidget *);
void open_file_ok(GtkWidget *, GtkFileSelection *);
void save_file_ok(GtkWidget *, GtkFileSelection *);
void new_file ();
void close_message_dialog (GtkWidget *, gpointer);
void ungrab_message(GtkWidget *, gpointer);
void display_dialog (gchar *, gchar *);
void find_function (GtkWidget *, gpointer);
gint look_for_string (gchar *, gint);
GtkWidget * entry_in_frame (gchar *,struct frame_entry *);
void set_title_name();
gboolean does_file_exist(gchar *);
gboolean is_file_readonly(gchar *);
gboolean is_file_a_directory(gchar *);
#endif /* GE_FUNCTIONS_H */
