/* ge -- gtk editor
 * Copyright 1999 David Vogler <david@rhlx01.rz.fht-esslingen.de>
 *		  Adrian Reber <adrian@rhlx01.rz.fht-esslingen.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "ge.h"

GtkWidget* main_menu(GtkWidget *window, GtkWidget **menubar)
{
  GtkItemFactory *factory;
  GtkAccelGroup *accel_group;
  static GtkItemFactoryEntry menu_items[] = {
	{"/_File",      NULL,   0,              0,      "<Branch>"},
	{"/File/_New",	"<control>N",   new_file,0},
	{"/File/_Open",	"<control>O",	open_file_dlg,	0},
	{"/File/_Save", "<control>S",   save_file,      0},
	{"/File/Save _As",NULL,	save_file_dlg,0},
	{"/File/_Quit", "<control>Q",   quit_program,0},
	{"/_Edit",      NULL,   0,              0,      "<Branch>"},
	{"/Edit/Cut",   "<control>X",   cut_to_clipboard,       0},
	{"/Edit/Copy",  "<control>C",   copy_to_clipboard,      0},
	{"/Edit/Paste", "<control>V",   paste_from_clipboard,   0},
	{"/Edit/sep",   NULL,   0,      0,      "<Separator>"},
	{"/Edit/Find", "F3", find_dlg,0},
	{"/_Help",      NULL,   0,      0,      "<LastBranch>"},
	{"/Help/_About",        NULL,   help_about_menu,        0}
};
  gint nmenu_items = sizeof (menu_items) / sizeof (menu_items[0]);
  accel_group = gtk_accel_group_new();
  factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>", accel_group);
  gtk_item_factory_create_items (factory, nmenu_items, menu_items, NULL);
  gtk_accel_group_attach (accel_group, GTK_OBJECT (window));
  if (menubar)
	  *menubar = gtk_item_factory_get_widget (factory, "<main>");
  return *menubar;
}
