/* ge -- gtk editor
 * Copyright 1999 David Vogler <david@rhlx01.rz.fht-esslingen.de>
 *		  Adrian Reber <adrian@rhlx01.rz.fht-esslingen.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */


#include "ge.h"
#include "pixmaps.h"

GtkWidget* main_toolbar(GtkWidget *main_window,GtkWidget *text)
{
  GtkWidget *toolbar, *pixmap_wid;
  GtkStyle *style;
  GdkPixmap *pixmap;
  GdkBitmap *mask;

  GdkWindow *window;

  toolbar =gtk_toolbar_new(GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_ICONS);
  style = gtk_widget_get_style(main_window);

  window=main_window->window;

  gtk_tooltips_set_colors(GTK_TOOLBAR(toolbar)->tooltips,
		  get_main_tooltips_bgcolor
			  (main_window->window,gdk_window_get_colormap(window)),
			   &style->fg[GTK_STATE_NORMAL]);


  gtk_tooltips_set_delay(GTK_TOOLBAR(toolbar)->tooltips, 100);

  pixmap = gdk_pixmap_create_from_xpm_d(
		main_window->window,
		&mask, &style->bg[GTK_STATE_NORMAL],
		(gchar **)tb_new_xpm);

  pixmap_wid = gtk_pixmap_new(pixmap, mask);
  gtk_widget_show(pixmap_wid);

  gtk_toolbar_append_item(
		GTK_TOOLBAR(toolbar),
		NULL, "New", NULL,
		pixmap_wid,
		GTK_SIGNAL_FUNC(new_file),
		NULL);

gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));

  gtk_tooltips_set_colors(GTK_TOOLBAR(toolbar)->tooltips,
		  get_main_tooltips_bgcolor
			  (main_window->window,gdk_window_get_colormap(window)),
			   &style->fg[GTK_STATE_NORMAL]);


  gtk_tooltips_set_delay(GTK_TOOLBAR(toolbar)->tooltips, 100);

  pixmap = gdk_pixmap_create_from_xpm_d(
		main_window->window,
		&mask, &style->bg[GTK_STATE_NORMAL],
		(gchar **)tb_open_xpm);

  pixmap_wid = gtk_pixmap_new(pixmap, mask);
  gtk_widget_show(pixmap_wid);

  gtk_toolbar_append_item(
		GTK_TOOLBAR(toolbar),
		NULL, "Open", NULL,
		pixmap_wid,
		GTK_SIGNAL_FUNC(open_file_dlg),
		NULL);


  gtk_tooltips_set_colors(GTK_TOOLBAR(toolbar)->tooltips,
		  get_main_tooltips_bgcolor
			  (main_window->window,gdk_window_get_colormap(window)),
			   &style->fg[GTK_STATE_NORMAL]);


  gtk_tooltips_set_delay(GTK_TOOLBAR(toolbar)->tooltips, 100);

  pixmap = gdk_pixmap_create_from_xpm_d(
		main_window->window,
		&mask, &style->bg[GTK_STATE_NORMAL],
		(gchar **)tb_save_xpm);

  pixmap_wid = gtk_pixmap_new(pixmap, mask);
  gtk_widget_show(pixmap_wid);

  gtk_toolbar_append_item(
		GTK_TOOLBAR(toolbar),
		NULL, "Save", NULL,
		pixmap_wid,
		GTK_SIGNAL_FUNC(save_file),
		NULL);


 gtk_tooltips_set_colors(GTK_TOOLBAR(toolbar)->tooltips,
			 get_main_tooltips_bgcolor
			 (main_window->window,gdk_window_get_colormap(window)),
			   &style->fg[GTK_STATE_NORMAL]);


  gtk_tooltips_set_delay(GTK_TOOLBAR(toolbar)->tooltips, 100);

  pixmap = gdk_pixmap_create_from_xpm_d(
		main_window->window,
		&mask, &style->bg[GTK_STATE_NORMAL],
		(gchar **)tb_exit_xpm);

  pixmap_wid = gtk_pixmap_new(pixmap, mask);
  gtk_widget_show(pixmap_wid);

  gtk_toolbar_append_item(
		GTK_TOOLBAR(toolbar),
		NULL, "Quit", NULL,
		pixmap_wid,
		GTK_SIGNAL_FUNC(quit_program),
		NULL);


  gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));

  gtk_tooltips_set_colors(GTK_TOOLBAR(toolbar)->tooltips,
			 get_main_tooltips_bgcolor
			 (main_window->window,gdk_window_get_colormap(window)),
			   &style->fg[GTK_STATE_NORMAL]);


  gtk_tooltips_set_delay(GTK_TOOLBAR(toolbar)->tooltips, 100);

  pixmap = gdk_pixmap_create_from_xpm_d(
		main_window->window,
		&mask, &style->bg[GTK_STATE_NORMAL],
		(gchar **)tb_cut_xpm);

  pixmap_wid = gtk_pixmap_new(pixmap, mask);
  gtk_widget_show(pixmap_wid);

  gtk_toolbar_append_item(
		GTK_TOOLBAR(toolbar),
		NULL, "Cut\tCtrl+X", NULL,
		pixmap_wid,
		GTK_SIGNAL_FUNC(cut_to_clipboard),
		NULL);


   gtk_tooltips_set_colors(GTK_TOOLBAR(toolbar)->tooltips,
			 get_main_tooltips_bgcolor
			 (main_window->window,gdk_window_get_colormap(window)),
			   &style->fg[GTK_STATE_NORMAL]);


  gtk_tooltips_set_delay(GTK_TOOLBAR(toolbar)->tooltips, 100);

  pixmap = gdk_pixmap_create_from_xpm_d(
		main_window->window,
		&mask, &style->bg[GTK_STATE_NORMAL],
		(gchar **)tb_copy_xpm);

  pixmap_wid = gtk_pixmap_new(pixmap, mask);
  gtk_widget_show(pixmap_wid);

  gtk_toolbar_append_item(
		GTK_TOOLBAR(toolbar),
		NULL, "Copy\tCtrl+C", NULL,
		pixmap_wid,
		GTK_SIGNAL_FUNC(copy_to_clipboard),
		NULL);


 gtk_tooltips_set_colors(GTK_TOOLBAR(toolbar)->tooltips,
			 get_main_tooltips_bgcolor
			 (main_window->window,gdk_window_get_colormap(window)),
			   &style->fg[GTK_STATE_NORMAL]);


  gtk_tooltips_set_delay(GTK_TOOLBAR(toolbar)->tooltips, 100);

  pixmap = gdk_pixmap_create_from_xpm_d(
		main_window->window,
		&mask, &style->bg[GTK_STATE_NORMAL],
		(gchar **)tb_paste_xpm);

  pixmap_wid = gtk_pixmap_new(pixmap, mask);
  gtk_widget_show(pixmap_wid);

  gtk_toolbar_append_item(
		GTK_TOOLBAR(toolbar),
		NULL, "Paste\tCtrl+V", NULL,
		pixmap_wid,
		GTK_SIGNAL_FUNC(paste_from_clipboard),
		NULL);
  /* Search Button */
  gtk_tooltips_set_colors(GTK_TOOLBAR(toolbar)->tooltips,
			 get_main_tooltips_bgcolor
			 (main_window->window,gdk_window_get_colormap(window)),
			   &style->fg[GTK_STATE_NORMAL]);


  gtk_tooltips_set_delay(GTK_TOOLBAR(toolbar)->tooltips, 100);

  pixmap = gdk_pixmap_create_from_xpm_d(
		main_window->window,
		&mask, &style->bg[GTK_STATE_NORMAL],
		(gchar **)search_xpm);

  pixmap_wid = gtk_pixmap_new(pixmap, mask);
  gtk_widget_show(pixmap_wid);

  gtk_toolbar_append_item(
		GTK_TOOLBAR(toolbar),
		NULL, "Search", NULL,
		pixmap_wid,
		GTK_SIGNAL_FUNC(find_dlg),
		NULL);


  return toolbar;
}

