/* GTKstereograph 0.18b, 17/11/2003;
 * Copyright (c) 2000-2003 by Fabian Januszewski <fabian.linux@januszewski.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#define _GNU_SOURCE

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>

#include <gtk/gtk.h>

#include "globals.h"
// #include "renderer.h"
// #include "gfxio.h"

#include "interface.h"
#include "support.h"
#include "callbacks.h"

int
main (int argc, char *argv[])
{
	stereograph_verbose = 0;

	Renderer_Param_Init( &Renderer_Params );
	Renderer_GFX_Init( &Renderer_Data , &GFX_Base, &GFX_Texture, &GFX_Stereo);

	Stereo_Triangles = 0;

	// the following inits are done only to syncro with the interface predefined params */
	Renderer_Params.Linear = 1;
	Renderer_Params.T_Layers = 0;
	Renderer_Params.Zoom = 1;
	Renderer_Params.AA = 4;
	Renderer_Params.AAr = 0;
	Renderer_Params.StartX = 0;
	Renderer_Params.StartY = 0;
	Renderer_Params.Front = 0.5;
	Renderer_Params.Distance = 5.0;
	Renderer_Params.Eyeshift = 0.0;

	GFX_Base.Data = NULL;
	GFX_Texture.Data = NULL;
	GFX_Stereo.Data = NULL;
	base_file_name = NULL;
	texture_file_name = NULL;
	stereo_file_name = NULL;
	// T_base_file_name = NULL;
	// T_texture_file_name = NULL;


  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
  add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");

    gdk_rgb_init();

    gtk_widget_set_default_colormap (gdk_rgb_get_cmap());
    gtk_widget_set_default_visual (gdk_rgb_get_visual());

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */

  /* gtk front end startup stuff */
  main_window1 = create_main_window1 ();

  gfx_tex_to_merge[0] = NULL;
  gfx_tex_to_merge[1] = NULL;
  gfx_tex_to_merge[2] = NULL;

  resize_window1 = NULL;
  generate_window1 = NULL;
  tex_align_window1 = NULL;
  base_gfx_window1 = NULL;
  texture_gfx_window1 = NULL;
  stereo_gfx_window1 = NULL;
  //gfx_window1 = NULL;
  info_dialog1 = NULL;
  base_open_dialogue1 = NULL;
  texture_open_dialogue1 = NULL;
  base_editor1 = NULL;
  texture_editor1 = NULL;   
  stereogram_save_dialogue1 = NULL;
  stereograph_include_dir = malloc(strlen(PACKAGE_DATA_DIR)+15);
  sprintf(stereograph_include_dir, "%s/include", PACKAGE_DATA_DIR);

  gtk_widget_show (main_window1);

  gtk_main ();

  if(GFX_Base.Data)
	free(GFX_Base.Data);
  if(GFX_Texture.Data)
	free(GFX_Texture.Data);
  if(gfx_tex_to_merge[0])
	if(gfx_tex_to_merge[0]->Data)
		free(gfx_tex_to_merge[0]->Data);
  if(GFX_Stereo.Data)
	Renderer_Close( &Renderer_Data );

  return 0;
}

